void TronWidget::think(void)
{
    int lookForward = 15;

    if (m_level != 0) {
	enum Dir sides[2];
	int flags[6]={0,0,0,0,0,0};
	int index[2];
	int dis_forward, dis_left, dis_right;

	dis_forward = dis_left = dis_right = 1;

  	switch (m_computer_dir) {
		case West:
    			//forward flags
    			flags[0] = -1;
    			flags[1] = 0;

    			//left flags
    			flags[2] = 0;
    			flags[3] = 1;

    			// right flags
    			flags[4] = 0;
    			flags[5] = -1;

    			//turns to either side
    			sides[0] = South;
    			sides[1] = North;
    			break;
		case East:
    			flags[0] = 1;
    			flags[1] = 0;
    			flags[2] = 0;
			   flags[3] = -1;
    			flags[4] = 0;
    			flags[5] = 1;
    			sides[0] = North;
    			sides[1] = South;
    			break;
		case North:
    			flags[0] = 0;
    			flags[1] = -1;
    			flags[2] = -1;
    			flags[3] = 0;
    			flags[4] = 1;
    			flags[5] = 0;
    			sides[0] = West;
    			sides[1] = East;
    			break;
		case South:
    			flags[0] = 0;
    			flags[1] = 1;
    			flags[2] = 1;
    			flags[3] = 0;
    			flags[4] = -1;
    			flags[5] = 0;
    			sides[0] = East;
    			sides[1] = West;
    			break;
  		}

  		// check forward
  		index[0] = m_computer_x+flags[0];
  		index[1] = m_computer_y+flags[1];
  		while (index[0] < cols && index[0] >= 0 &&
	 		index[1] < rows && index[1] >= 0 &&
	 		m_field[index[1]][index[0]] == Empty)
	 	{
    		dis_forward++;
    		index[0] += flags[0];
    		index[1] += flags[1];
  		}

    	// check left
    	index[0] = m_computer_x+flags[2];
    	index[1] = m_computer_y+flags[3];
    while (index[0] < cols && index[0] >= 0 &&
	   index[1] < rows && index[1] >= 0 &&
	   m_field[index[1]][index[0]] == Empty) {
      dis_left++;
      index[0] += flags[2];
      index[1] += flags[3];
    }

    // check right
    index[0] = m_computer_x+flags[4];
    index[1] = m_computer_y+flags[5];
    while (index[0] < cols && index[0] >= 0 &&
	   index[1] <  rows && index[1] >= 0 &&
	   m_field[index[1]][index[0]] == Empty) {
      dis_right++;
      index[0] += flags[4];
      index[1] += flags[5];
    }

  	// distances to opponent
  	int hor_dis=0; // negative is opponent to the right
  	int vert_dis=0; // negative is opponent to the bottom
  	hor_dis=m_computer_x-m_player_x;
  	vert_dis=m_computer_y-m_player_y;

  	int opForwardDis=0; // negative is to the back
  	int opSideDis=0;  // negative is to the left
  	bool opMovesOppositeDir=false;
  	bool opMovesSameDir=false;
  	bool opMovesEast=false;
  	bool opMovesWest=false;

  	switch(m_computer_dir)
  	{
  	   case North:
  	      opForwardDis=vert_dis;
  	      opSideDis=-hor_dis;
  	      if(m_player_dir==South)
  	         opMovesOppositeDir=true;
  	      else if(m_player_dir==North)
  	         opMovesSameDir=true;
  	      else if(m_player_dir==West)
  	         opMovesWest=true;
  	      else if(m_player_dir==East)
  	         opMovesEast=true;
  	      break;
  	   case South:
  	      opForwardDis=-vert_dis;
  	      opSideDis=hor_dis;
  	      if(m_player_dir==North)
  	         opMovesOppositeDir=true;
  	      else if(m_player_dir==South)
  	         opMovesSameDir=true;
  	      else if(m_player_dir==West)
  	         opMovesEast=true;
  	      else if(m_player_dir==East)
  	         opMovesWest=true;
  	      break;
  	   case West:
  	      opForwardDis=hor_dis;
  	      opSideDis=vert_dis;
  	      if(m_player_dir==East)
  	         opMovesOppositeDir=true;
  	      else if(m_player_dir==West)
  	         opMovesSameDir=true;
  	      else if(m_player_dir==South)
  	         opMovesWest=true;
  	      else if(m_player_dir==North)
  	         opMovesEast=true;
  	      break;
  	   case East:
  	      opForwardDis=-hor_dis;
  	      opSideDis=-vert_dis;
  	      if(m_player_dir==West)
  	         opMovesOppositeDir=true;
  	      else if(m_player_dir==East)
  	         opMovesSameDir=true;
  	      else if(m_player_dir==North)
  	         opMovesWest=true;
  	      else if(m_player_dir==South)
  	         opMovesEast=true;
  	      break;
  	}

  	int doPercentage=100;
  	if(m_level == 1)
  		doPercentage=5;
  	else if(m_level == 2)
  		doPercentage=90;

  	// if opponent moves the opposite direction as we
   if(opMovesOppositeDir)
   {
      // if opponent is in front
      if(opForwardDis>0)
      {
         // opponent is to the right and we have the chance to block the way
         if(opSideDis>0 && opSideDis < opForwardDis && opSideDis < dis_right && opForwardDis < lookForward)
         {
            if ((rand() % 100) <= doPercentage || dis_forward==1)
               m_computer_dir = sides[1];
         }
         // opponent is to the left and we have the chance to block the way
         else if(opSideDis<0 && -opSideDis < opForwardDis && -opSideDis < dis_left && opForwardDis < lookForward)
         {
            if ((rand() % 100) <= doPercentage || dis_forward==1)
               m_computer_dir = sides[0];
         }
         // if we can do nothing, go forward
         else if(dis_forward < lookForward)
         {
      		dis_forward = 100 - 100/dis_forward;

    			if(!(dis_left == 1 && dis_right == 1))
      			if ((rand() % 100) >= dis_forward || dis_forward == 1)
         			changeDirection(dis_right,dis_left);
         }
      }
      // opponent is in back of us and moves away: do nothing
      else if(dis_forward < lookForward)
      {
      	dis_forward = 100 - 100/dis_forward;

    		if(!(dis_left == 1 && dis_right == 1))
      		if ((rand() % 100) >= dis_forward || dis_forward == 1)
        			changeDirection(dis_right,dis_left);
      }
   } // end  if(opMovesOppositeDir)

   else if(opMovesSameDir)
   {
      // if opponent is to the back
      if(opForwardDis < 0)
      {
        	// opponent is to the right and we have the chance to block the way
         if(opSideDis>0 && opSideDis < -opForwardDis && opSideDis < dis_right)
         {
            if ((rand() % 100) <= doPercentage || dis_forward==1)
               m_computer_dir = sides[1];
         }
         // opponent is to the left and we have the chance to block the way
         else if(opSideDis<0 && -opSideDis < -opForwardDis && -opSideDis < dis_left)
         {
            if ((rand() % 100) <= doPercentage || dis_forward==1)
               m_computer_dir = sides[0];
         }
         // if we can do nothing, go forward
         else if(dis_forward < lookForward)
         {
      		dis_forward = 100 - 100/dis_forward;

    			if(!(dis_left == 1 && dis_right == 1))
      			if ((rand() % 100) >= dis_forward || dis_forward == 1)
         			changeDirection(dis_right,dis_left);
         }
      }
      // opponent is in front of us and moves away
      else if(dis_forward < lookForward)
      {
      	dis_forward = 100 - 100/dis_forward;

    		if(!(dis_left == 1 && dis_right == 1))
      		if ((rand() % 100) >= dis_forward || dis_forward == 1)
        			changeDirection(dis_right,dis_left);
      }
   } // end if(opMovesSameDir)

   else if(opMovesEast)
   {
      // opponent is in front of us
      if(opForwardDis>0)
      {
          // opponent is to the left
          if(opSideDis < 0 && -opSideDis < opForwardDis && -opSideDis < dis_left)
          {
             if(opForwardDis < lookForward && dis_left > lookForward)
             {
	          	 if ((rand() % 100) <= doPercentage/2 || dis_forward==1)
               	changeDirection(dis_right,dis_left);
	          }
	          else if(dis_forward < lookForward)
      		 {
      			dis_forward = 100 - 100/dis_forward;

    				if(!(dis_left == 1 && dis_right == 1))
      				if ((rand() % 100) >= dis_forward || dis_forward == 1)
        					changeDirection(dis_right,dis_left);
      		 }
          }
          // op is to the right and moves away, but maybe we can block him
          else if(opSideDis>=0 && opSideDis < dis_right)
          {
             if(opForwardDis < lookForward && dis_right>lookForward)
             {
            	if ((rand() % 100) <= doPercentage/2 || dis_forward==1)
               m_computer_dir = sides[1];
             }
	          else if(dis_forward < lookForward)
      		 {
      			dis_forward = 100 - 100/dis_forward;

    				if(!(dis_left == 1 && dis_right == 1))
      				if ((rand() % 100) >= dis_forward || dis_forward == 1)
        					changeDirection(dis_right,dis_left);
      		 }
          }
          else if(dis_forward < lookForward)
      	 {
      		dis_forward = 100 - 100/dis_forward;

    			if(!(dis_left == 1 && dis_right == 1))
      			if ((rand() % 100) >= dis_forward || dis_forward == 1)
        				changeDirection(dis_right,dis_left);
      	 }
      }
      // opponent is in the back of us
      else
      {
         // opponent is right from us and we already blocked him
         if(opSideDis>0 && opForwardDis < lookForward && opSideDis < dis_right)
         {
            if ((rand() % 100) <= doPercentage/2 || dis_forward==1)
               	changeDirection(dis_right,dis_left);
         }
      	else if(dis_forward<lookForward)
      	{
      		dis_forward = 100 - 100/dis_forward;

    			if(!(dis_left == 1 && dis_right == 1))
      			if ((rand() % 100) >= dis_forward || dis_forward == 1)
        				changeDirection(dis_right,dis_left);
      	}
      }
   } // end if(opMovesEast)

   else if(opMovesWest)
   {
      // opponent is in front of us
      if(opForwardDis>0)
      {
          // opponent is to the right, moves towards us and could block us
          if(opSideDis > 0 && opSideDis < opForwardDis && opSideDis < dis_right)
          {
             if(opForwardDis < lookForward && dis_right>lookForward)
             {
          	 	if ((rand() % 100) <= doPercentage/2 || dis_forward==1)
               	changeDirection(dis_right,dis_left);
             }
          	 else if(dis_forward < lookForward)
      		 {
      			dis_forward = 100 - 100/dis_forward;

    				if(!(dis_left == 1 && dis_right == 1))
      				if ((rand() % 100) >= dis_forward || dis_forward == 1)
        					changeDirection(dis_right,dis_left);
      		 }
          }
          // op is to the left and moves away, but maybe we can block him
          else if(opSideDis<=0 && opSideDis < dis_left)
          {
             if(opForwardDis < lookForward && dis_left>lookForward)
             {
             	if ((rand() % 100) <= doPercentage/2 || dis_forward==1)
               m_computer_dir = sides[0];
				 }
	       	 else if(dis_forward < lookForward)
      		 {
      			dis_forward = 100 - 100/dis_forward;

    				if(!(dis_left == 1 && dis_right == 1))
      				if ((rand() % 100) >= dis_forward || dis_forward == 1)
        					changeDirection(dis_right,dis_left);
      		 }

          }
      	else if(dis_forward < lookForward)
      	{
      		dis_forward = 100 - 100/dis_forward;

    			if(!(dis_left == 1 && dis_right == 1))
      			if ((rand() % 100) >= dis_forward || dis_forward == 1)
        				changeDirection(dis_right,dis_left);
      	}
      }
      // opponent is in the back of us
      else //if(opForwardDis<=0)
      {
         // opponent is left from us and we already blocked him
         if(opSideDis<0 && opForwardDis < lookForward && -opSideDis < dis_left)
         {
            if ((rand() % 100) <= doPercentage/2 || dis_forward==1)
               	changeDirection(dis_right,dis_left);
         }
      	else if(dis_forward<lookForward)
      	{
      		dis_forward = 100 - 100/dis_forward;

    			if(!(dis_left == 1 && dis_right == 1))
      			if ((rand() % 100) >= dis_forward || dis_forward == 1)
        				changeDirection(dis_right,dis_left);
      	}
      }
   } // end if(opMovesWest)

}
// This part is completly ported from
// xtron-1.1 by Rhett D. Jacobs <rhett@hotel.canberra.edu.au>
else //_skill==Easy
{
  enum Dir sides[2];
  int flags[6] = {0,0,0,0,0,0};
  int index[2];
  int dis_forward,  dis_left, dis_right;

  dis_forward = dis_left = dis_right = 1;

  switch (m_computer_dir) {
  case West:

    //forward flags
    flags[0] = -1;
    flags[1] = 0;

    //left flags
    flags[2] = 0;
    flags[3] = 1;

    // right flags
    flags[4] = 0;
    flags[5] = -1;

    //turns to either side
    sides[0] = South;
    sides[1] = North;
    break;
  case East:
    flags[0] = 1;
    flags[1] = 0;
    flags[2] = 0;
    flags[3] = -1;
    flags[4] = 0;
    flags[5] = 1;
    sides[0] = North;
    sides[1] = South;
    break;
  case North:
    flags[0] = 0;
    flags[1] = -1;
    flags[2] = -1;
    flags[3] = 0;
    flags[4] = 1;
    flags[5] = 0;
    sides[0] = West;
    sides[1] = East;
    break;
  case South:
    flags[0] = 0;
    flags[1] = 1;
    flags[2] = 1;
    flags[3] = 0;
    flags[4] = -1;
    flags[5] = 0;
    sides[0] = East;
    sides[1] = West;
    break;
  }

  // check forward
  index[0] = m_computer_x+flags[0];
  index[1] = m_computer_y+flags[1];
  while (index[0] < cols && index[0] >= 0 &&
	 index[1] < rows && index[1] >= 0 &&
	 m_field[index[1]][index[0]] == Empty) {
    dis_forward++;
    index[0] += flags[0];
    index[1] += flags[1];
  }

  if (dis_forward < lookForward)
    {
      dis_forward = 100 - 100/dis_forward;

    // check left
    index[0] = m_computer_x+flags[2];
    index[1] = m_computer_y+flags[3];
    while (index[0] < cols && index[0] >= 0 &&
	   index[1] < rows && index[1] >= 0 &&
	   m_field[index[1]][index[0]] == Empty) {
      dis_left++;
      index[0] += flags[2];
      index[1] += flags[3];
    }

    // check right
    index[0] = m_computer_x+flags[4];
    index[1] = m_computer_y+flags[5];
    while (index[0] < cols && index[0] >= 0 &&
	   index[1] <  rows && index[1] >= 0 &&
	   m_field[index[1]][index[0]] == Empty) {
      dis_right++;
      index[0] += flags[4];
      index[1] += flags[5];
    }
    if(!(dis_left == 1 && dis_right == 1))
      if ((rand() % 100) >= dis_forward || dis_forward == 0) {

	// change direction
	if ((rand() % 100) <= (100*dis_left)/(dis_left+dis_right))
	  if (dis_left != 1)
	    m_computer_dir = sides[0];
	  else
	    m_computer_dir = sides[1];
	else
	  if (dis_right != 1)
	    m_computer_dir = sides[1];
	  else
	    m_computer_dir = sides[0];
      }
  }
 }
}

void TronWidget::changeDirection(int dis_right,int dis_left)
{
   enum Dir currentDir=m_computer_dir;
   enum Dir sides[2];
   switch (currentDir)
   {
  		case West:
    		//turns to either side
    		sides[0] = South;
    		sides[1] = North;
    		break;
  		case East:
    		sides[0] = North;
    		sides[1] = South;
    		break;
  		case North:
    		sides[0] = West;
    		sides[1] = East;
    		break;
  		case South:
    		sides[0] = East;
    		sides[1] = West;
    		break;
  	}

   if(!(dis_left == 1 && dis_right == 1))
   {
			// change direction
			if ((rand() % 100) <= (100*dis_left)/(dis_left+dis_right))
			{
	  			if (dis_left != 1)
				    m_computer_dir = sides[0];
		    		// turn to the left
	  			else
				    m_computer_dir = sides[1];
	   	 		// turn to the right
	    	}
			else
			{
	  				if (dis_right != 1)
	  					// turn to the right
				    m_computer_dir = sides[1];
	  				else
	    				// turn to the left
				    m_computer_dir = sides[0];
          }
    }
}

