/*
 * Copyright (C) 2002 Robert Ernst <robert.ernst@linux-solutions.at>
 *
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file LICENSE.GPL included in the
 * packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See COPYING for GPL licensing information.
 *
 */

#ifndef __TRON_HEADER__
#define __TRON_HEADER__

#include <qpe/qpemenubar.h>
#include <qmainwindow.h>
#include <qpopupmenu.h>
#include "TronWidget.h"

class Tron : public QMainWindow
{
    Q_OBJECT

public:
    Tron(QWidget *parent = 0, const char *name = 0, WFlags f = 0);
    ~Tron();

private:
    void readConfig(void);
    void writeConfig(void);

private:
    TronWidget *m_tronWidget;
    QPopupMenu *m_levelMenu;
    QPopupMenu *m_speedMenu;
    int m_level;
    int m_speed;

protected slots:
    void updateLevel(int level);
    void updateSpeed(int speed);
};

#endif // __TRON_HEADER__

